#!/bin/bash

### Copyright flurdy @ electric ray 2K4
### www.electricray.org

	# what is the most recent backup
	# do a diff backup since last backup
	# remove all daily ones	 older than $daylimit
	# if first time since start of week do full backup 
	# remove all weekly older than $weeklimit
	# if first time since start of month do month copy
	# remove all monthly older than $monthlimit
	# if first time since start of year do year copy

	# extension suggestions
	# check if run today
	# could check if size is very different
	# could check if litle disk space
	
config="/etc/backup/corecfg"

dates(){
	tdy=`date -I`
	wday=`date +%a`
	mday=`date +%d`
	week=`date +%W`
	month=`date +%m`
	monthname=`date +%b`
	year=`date +%Y`
}

paths(){
	arc=$bkfld/$alias.$tdy.tzp
	yarc=$bkfld/$alias.$year.tzp
	marc=$bkfld/$alias.$year-$monthname.tzp
	warc=$bkfld/$alias.$year-$week.tzp
	farc=$bkfld/$alias.$tdy.full.tzp
	carc=$bkfld/$alias.current.tzp
	tar=$tmpfld/$alias.tar
	zip=$tar.bz2
	pgp=$zip.gpg
	fld=`cat $alias`
}	

cleartmp(){
	rm -f $tar $zip $pgp
}

lastbk(){
	old=`ls $bkfld/$alias.????-??-??.tzp`
	for j in $old;
	do
		date=`echo $j | sed -e 's/.tzp$//' -e 's/^.*\.//'`
		then=`date -d $date +%s`
		when=`date -d $last +%s`				
		if [ $then -gt $when ]; then
			last=$date
		fi
	done
}

eyeup(){
	lwday=`date -d $last +%a`
	lmday=`date -d $last +%d`
	lweek=`date -d $last +%W`
	lmonth=`date -d $last +%m`
	lyear=`date -d $last +%Y`
}

tarall(){
	touch $tar
	tar cf $tar $fld
}

tarnew(){
	touch $tar
	tar cf $tar --after-date $last $fld
}

zipcrypt(){
	bzip2 -k $1
	gpg -e -r $usr $zip
}

#needfull(){
#	if [ "$year" -ne "$lyear" ]; then
#	  full=1
#	elif [ "$month" -ne "$lmonth" ]; then
#	  full=1
#	elif [ "$week" -ne "$lweek" ]; then
#	  full=1
#	fi
#}

rname(){
	rname=$1
	rnum=1
	rnew="$rname.$rnum"
	while [ -e "$rnew" ]; 
	do			
		rnum=$(($rnum+1))
		rnew=$rname.$rnum 
	done
}

createancestors(){	  
	if [ "$year" -ne "$lyear" ]; then
		if [ -e "$yarc" ]; then
			rname $yarc
			mv $yarc $rnew
		fi
		cp $pgp $yarc 
	fi
	if [ "$month" -ne "$lmonth" ]; then
		if [ -e "$marc" ]; then
			rname $marc
			mv $marc $rnew
		fi
		cp $pgp $marc
	fi
	if [ "$week" -ne "$lweek" ]; then
		if [ -e "$warc" ]; then
			rname $warc
			mv $warc $rnew
		fi
		cp $pgp $warc
	fi
}

breed(){
	full=0
	#needfull
	#if [ "$full" -ne 0 ]; then
		tarall
		zipcrypt $tar
	#fi
	createancestors
	cleartmp
	mv $pgp $farc
	ln -s $farc $carc
	tarnew
	zipcrypt $tar
	if [ -e "$arc" ]; then
		rname $arc
		mv $arc $rnew
	fi
	mv $pgp $arc				
}	

datecomp(){
	if [ "$1" -lt "$2" ]; then
		rm -f $5
	elif  [ "$1" -eq "$2" ]; then
		if  [ "$3" -lt "$4" ]; then
			rm -f $5
		fi
	fi
}

genetics(){
	cd $bkfld
	oldday=`date --date="$kday days ago" +%s`
	files=`ls $alias.????-??-??.tzp`	
	for k in $files;
	do
		date=`echo $k | sed -e 's/.tzp$//' -e 's/^.*\.//'`
		then=`date -d $date +%s`
		if [ $then -lt $oldday ]; then
			rm -f $k
		fi
	done
	oldww=`date --date="$kweek weeks ago" +"%W"`
	oldwy=`date --date="$kweek weeks ago" +"%Y"`
	files=`ls $alias.????-??.tzp`	
	for k in $files;
	do
		fwk=`echo $k | sed -e 's/.tzp$//' -e 's/^.*\-//'`
		fyr=`echo $k | sed -e 's/-..\.tzp$//' -e 's/^.*\.//'`
		datecomp $fyr $oldwy $fwk $oldww $k
	done
	oldmm=`date --date="$kmonth months ago" +"%m"`
	oldmy=`date --date="$kmonth months ago" +"%Y"`
	files=`ls $alias.????-???.tzp`	
	for k in $files;
	do
		fyr=`echo $k | sed -e 's/-...\.tzp$//' -e 's/^.*\.//'`
		fmn=`echo $k | sed -e 's/.tzp$//' -e 's/^.*\-//'`
		fmm=`date -d 10-$fmn-2004 +%m`
		datecomp $fyr $oldmy $fmm $oldmm $k
	done	  
}

report(){
	echo "Reporting not enabled"
}

dejavue(){
	if [ -e "$arc" ]; then
		donetdy=1
	fi
}

################
#clear
. $config
. $defaults
#echo $welcome
## set todays dates, eg. month week etc
dates
## get filename/alias of backups
cd $aliasfld
aliases=`ls *`
for i in $aliases; 
do
	## reset variables to defaults			
	. $defaults
	alias=$i
	## if the alias has its own variables
	if [ -e $cfgfld/$alias ]; then					
		. $cfgfld/$alias 
		## make sure it doesnt overwrite core variables
		. $config
	fi
	cd $aliasfld
	## set paths of files to be used
	paths	$i
	## check if done today
	dejavue
	if [ "$donetdy" -eq 0 ]; then
		## delete any old tmp files
		cleartmp
		## work out when last backup was done
		last="1970-01-01"
		lastbk
		## set dates of last backup
		eyeup
		## ## do backup and create week/month if needed
		breed
		## remove very old backups
		genetics
#	else
#		echo $alias already backed up today
	fi
	cleartmp	
done
## email results
#report
#echo $finish


